var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  default: () => index_default
});
module.exports = __toCommonJS(index_exports);
var import_purgecss = require("purgecss");
var import_crypto = __toESM(require("crypto"), 1);

// src/deprecated/templates/get-template-path.ts
var templates = {
  blade: "resources/views/**/*.blade.php",
  svelte: "resources/{js,views}/**/*.svelte",
  vue: "resources/{js,views}/**/*.vue",
  react: "resources/{js,views}/**/*.{tsx,ts,jsx,js,html}",
  angular: "resources/{js,views}/**/*.html"
};
var get_template_path_default = (template) => {
  if (!(template in templates))
    throw new Error(`Template ${template} is not supported`);
  return templates[template];
};

// src/deprecated/templates/process-templates.ts
var process_templates_default = (templates2) => {
  const paths = [];
  if (templates2?.length > 0) {
    console.warn(
      `
[@erbelion/vite-plugin-laravel-purgecss] The "templates" option is deprecated and will be removed in a future release. Please use "paths" instead.`
    );
  }
  templates2?.forEach((template) => paths.push(get_template_path_default(template)));
  return paths;
};

// src/filter-options.ts
var filter_options_default = (options) => {
  const paths = [];
  options?.paths?.forEach((path) => paths.push(path));
  paths.concat(process_templates_default(options?.templates));
  if (paths.length === 0) {
    paths.push("resources/{js,views}/**/*.{blade.php,svelte,vue,html}");
  }
  const rehash = options?.rehash !== void 0 ? options.rehash : true;
  const purgeOptions = options;
  const keysToDelete = ["css", "content", "paths", "templates", "rehash"];
  if (purgeOptions) {
    keysToDelete.forEach((key) => delete purgeOptions[key]);
  }
  return {
    paths,
    purgeOptions,
    rehash
  };
};

// src/index.ts
var isOutputAsset = (bundle) => bundle.type === "asset";
var hash = (content) => import_crypto.default.createHash("sha256").update(content).digest("hex").slice(0, 8);
var index_default = (_options) => {
  return {
    name: "vite-plugin-laravel-purgecss",
    enforce: "post",
    async generateBundle(_, bundle) {
      const { paths, purgeOptions, rehash } = filter_options_default(_options);
      const cssFiles = Object.keys(bundle).filter(
        (key) => key.endsWith(".css")
      );
      if (!cssFiles) return;
      for (const file of cssFiles) {
        const asset = bundle[file];
        if (!isOutputAsset(asset)) continue;
        const purged = await new import_purgecss.PurgeCSS().purge({
          content: paths,
          css: [{ raw: asset.source }],
          ...purgeOptions
        });
        const newCss = purged[0].css;
        if (!rehash) {
          asset.source = newCss;
          continue;
        }
        const newFileName = file.replace(
          /\.css$/,
          `-${hash(newCss)}.css`
        );
        delete bundle[file];
        bundle[newFileName] = {
          ...asset,
          fileName: newFileName,
          source: newCss,
          type: "asset"
        };
      }
    }
  };
};
